food_project/urls.py
from django.contrib import admin
from django.contrib.auth.views import LogoutView
from django.urls import path, include

from food_project.views import Login, home

urlpatterns = [
    path('admin/', admin.site.urls),
    path("", home, name="homepage"),
    path("login/", Login.as_view(), name="login"),
    path("logout/", LogoutView.as_view(), name="logout"),
    path("menu/", include("menu.urls"))
]

menu/urls.py
from django.urls import path

from menu.views import CategoriaDiCiboDetailView, CategoriaDiCiboListView, CategoriaDiCiboCreateView, \
    CategoriaDiCiboUpdateView, CategoriaDiCiboDeleteView

app_name = "menu"

urlpatterns = [
    path(
        "categorie/",
        CategoriaDiCiboListView.as_view(),
        name="lista_categorie"
    ),
    path(
        "categoria/<int:pk>/",
        CategoriaDiCiboDetailView.as_view(),
        name="dettaglio_categoria"
    ),
    path(
        "categoria/nuova/",
        CategoriaDiCiboCreateView.as_view(),
        name="nuova_categoria"
    ),
    path(
        "categoria/<int:pk>/aggiorna/",
        CategoriaDiCiboUpdateView.as_view(),
        name="modifica_categoria"
    ),
    path(
        "categoria/<int:pk>/elimina/",
        CategoriaDiCiboDeleteView.as_view(),
        name="elimina_categoria"
    ),
]

menu/models.py
from django.db import models



class CategoriaDiCibo(models.Model):

    nome = models.CharField(max_length=255)
    descrizione = models.TextField()


class Pietanza(models.Model):

    nome = models.CharField(max_length=255)
    descrizione = models.TextField()

    categoria = models.ForeignKey(
        CategoriaDiCibo, on_delete=models.PROTECT,
        related_name="pietanze"
    )

food_project/views.py
from django.contrib.auth.forms import AuthenticationForm
from django.contrib.auth.views import LoginView

from django.shortcuts import render

__all__ = ["home", "Login"]


def home(request):
    return render(request, "home.html")


class Login(LoginView):
    authentication_form = AuthenticationForm
    template_name = "authentication/login.html"

menu/views.py
from django.contrib.auth.decorators import login_required
from django.urls import reverse_lazy
from django.utils.decorators import method_decorator
from django.views.generic import (
    CreateView,
    DeleteView,
    DetailView,
    ListView,
    UpdateView,
)

from menu.models import CategoriaDiCibo

__all__ = [
    "CategoriaDiCiboCreateView",
    "CategoriaDiCiboDeleteView",
    "CategoriaDiCiboDetailView",
    "CategoriaDiCiboListView",
    "CategoriaDiCiboUpdateView",
]


class CategoriaDiCiboListView(ListView):
    model = CategoriaDiCibo


class CategoriaDiCiboDetailView(DetailView):
    model = CategoriaDiCibo


@method_decorator(login_required, name="dispatch")
class CategoriaDiCiboCreateView(CreateView):
    model = CategoriaDiCibo
    fields = ("nome", "descrizione")

    success_url = reverse_lazy("menu:lista_categorie")


@method_decorator(login_required, name="dispatch")
class CategoriaDiCiboUpdateView(UpdateView):
    model = CategoriaDiCibo
    fields = ("nome", "descrizione")

    def get_success_url(self):
        return reverse_lazy(
            "menu:dettaglio_categoria",
            kwargs={"pk": self.object.id}
        )


@method_decorator(login_required, name="dispatch")
class CategoriaDiCiboDeleteView(DeleteView):
    model = CategoriaDiCibo

    success_url = reverse_lazy("menu:lista_categorie")

menu/templates/menu/categoriadicibo_confirm_delete.html
{% extends "base.html" %}
{% load crispy_forms_tags %}

{% block content %}
<h1>Conferma eliminazione</h1>

<p>
    <a href="{% url 'menu:lista_categorie' %}">
        Annulla / Torna indietro
    </a>
</p>
<p>Conferma eliminazione della categoria "{{ object.nome }}"</p>
<form action="" method="post">
    {% csrf_token %}
    <input type="submit" value="Conferma">
</form>

{% endblock %}

menu/templates/menu/categoriadicibo_detail.html
{% extends "base.html" %}

{% block content %}
<h1>Categoria {{ object.id }}: {{object.nome}}</h1>

<p>
    <a href="{% url 'menu:lista_categorie' %}">
        Torna alla lista di categorie
    </a>
</p>

<p>{{ object.descrizione }}</p>

<hr>

<ul>
    {% for el in object.pietanze.all %}
        <li>{{ el.nome }}</li>
    {% endfor %}
</ul>

{% endblock %}

menu/templates/menu/categoriadicibo_form.html
{% extends "base.html" %}

{% load crispy_forms_tags %}

{% block content %}
<h1>Form categoria</h1>

<p>
    <a href="{% url 'menu:lista_categorie' %}">
        Annulla / Torna indietro
    </a>
</p>

<form action="" method="post">
    {% csrf_token %}

    {{ form | crispy }}

    <input type="submit" value="Salva">
</form>

{% endblock %}

menu/templates/menu/categoriadicibo_list.html
{% extends "base.html" %}

{% block content %}
<h1>Lista di Categorie</h1>

{% for el in object_list %}
    <p>
        {{ el.id }}) {{ el.nome }} -
        <a href="{% url 'menu:dettaglio_categoria' el.id %}">
            Visualizza dettaglio
        </a>
        (
        <a href="{% url 'menu:modifica_categoria' el.id %}">
            Modifica
        </a>
        -
        <a href="{% url 'menu:elimina_categoria' el.id %}">
            Elimina
        </a>
        )
    </p>
{% endfor %}

<hr>

<p>
    <a href="{% url 'menu:nuova_categoria' %}">
        Crea nuova
    </a>
</p>

{% endblock %}

templates/authentication/login.html
{% extends "base.html" %}

{% load crispy_forms_tags %}

{% block content %}
<h1>Effettua il login</h1>

<form action="" method="post">
    {% csrf_token %}
    {{ form | crispy }}

    <input type="submit" value="Login">
</form>

{% endblock %}

templates/base.html
{% load static %}<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Il mio sito bellissimo</title>

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>

    <link rel="stylesheet" href="{% static 'style.css' %}">

</head>
<body>
    <nav class="container navbar">
        <a href="{% url 'homepage' %}" class="nav-item">Home</a>
        |
        <a href="{% url 'menu:lista_categorie' %}" class="nav-item">Categorie di Cibo</a>
        |
        {% if user.is_anonymous %}
            <a href="{% url 'login' %}" class="nav-item">Login</a>
        {% else %}
            <a href="{% url 'logout' %}" class="nav-item">Logout</a>
        {% endif %}
    </nav>
    <hr>
    {% if user.is_authenticated %}
        <p class="container">
            Ciao {{ user.username }}!
        </p>
    {% endif %}
    <main class="container">
      {% block content %}
        Contenuto di default - da sovrascrivere
      {% endblock %}
    </main>
</body>
</html>

templates/home.html
{% extends "base.html" %}

{% block content %}
<h1>Welcome!</h1>
<p>Questa è la Home</p>
<p>Lorem ipsum</p>
{% endblock %}